#include <assert.h>
#include "ezwin.h"
#include "bitmap.h"
#include <cstring>
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>

using namespace std;
// haven't decided the dimensions
SimpleWindow game("iSnake",8.0,8.0, Position(11.0 ,3.0));
SimpleWindow menu("iSnake",8.0,8.0, Position(11.0 ,3.0));
SimpleWindow gameover("Gave Over",8.0 ,8.0 , Position(11.0 ,3.0));
SimpleWindow hs("Game Over",8.0 ,8.0 , Position(11.0,3.0));
SimpleWindow highs("High Scores",8.0,8.0, Position(11.0,3.0));
SimpleWindow instruc("Instructions",8.0,8.0, Position(11.0,3.0));

/* Variable Description
 
 snake   : represents the snake
 HS      : stores the highscores
 map	 : represents the map, stores info about the maze, fruits etc;
 lives	 : represents the lives remaining for the snake
 level	 : represents the current level in the game
 length  : represents the length of the snake
 direc	 : represents the direction of the snake
 score	 : represents the current score in the game
 levelscore : rperesents the score in the current level
 xfruit	 : represents the x coordinate of the fruit
 yfruit	 : represents the y coordinate of the fruit
 xbonusfruit : represents the x coordinate of the bonus fruit
 ybonusfruit : represents the y coordinate of the bonus fruit
 lengthinc : used to represent if snake has eaten the fruit
 bonusfruitpresence : used to specify presence of bonus fruit
 countr  : variable used to blink the bonus fruit
 n,r,c	 : variables used to display the higscores
 
 */
struct snakebody
{
	int x;
	int y;
}snake[30];
int HS[3];
int map[20][20]; // havent decided the dimensions of the map
int lives;
int level;
int length;
char direc;
int score=0;
int levelscore=0;
int xfruit;
int yfruit;
int xbonusfruit;
int ybonusfruit;
int lengthinc=0;
int bonusfruitpresence=0;
int countr=0;
int n;
int r;
int c;


// bitmaps declaration
BitMap blank(game);
BitMap head(game);
BitMap body(game);
BitMap fruit(game);
BitMap bonusfruit(game);
BitMap wall(game);
BitMap highscore(hs);
BitMap background(menu);
BitMap back(highs);
BitMap b(instruc);
BitMap instructions(instruc);
BitMap highback(highs);
BitMap go(gameover);
BitMap zero(highs);
BitMap one(highs);
BitMap two(highs);
BitMap three(highs);
BitMap four(highs);
BitMap five(highs);
BitMap six(highs);
BitMap seven(highs);
BitMap eight(highs);
BitMap nine(highs);


/* Function Description
 
 HSload	       : loads the highscores onto the HS array
 loadmenu	   : loads the bitmap in the menu window
 mainmenu	   : handles the mouse clicks on the main menu
 mainmenuclick : handles the mouse click in the main menu
 HSdisplay	   : displays the highscores
 loadinstructions : displays the instructions 
 exitmenu	   : used to quit the game
 exitwindowclick : handles the mouse click in the exit menu
 loadgame	   : loads the bitmaps 	
 playgame	   : start the game	
 load		   : prepares the level	
 loadmap	   : loads the map coordinates
 plotfruit	   : plots the fruits randomly
 genrandom	   : generates random numbers
 endgame	   : end the game
 checkscore	   : checks if the score is a highscore
 gameoverclick : handles the mouse click in the gameover window
 turn		   : loads the appropriate head bitmap
 gamewindowclick : handles the mouse click in the game window
 move		   : moves the snake
 check		   : checks the validity of each move
 plotbonusfruit : plots the bonus fruit randomly
 timerclick	   : get called repeatedly after a time interval
 handleBonusFruit : handles the bonus fruit
 hsclick	   : handles the mouse click in the hs window
 highsclick	   : handles the mouse click in the highs window
 instrucclick  : handles the mouse click in the instruc window
 drawnumber    : function to display the highscores
 
 */

int HSload();
int loadmenu();
int mainmenu();
int mainmenuclick(const Position &p);
int HSdisplay();
int loadinstructions();
int exitmenu();
int exitwindowclick(const Position &p);
int loadgame();
int playgame();
int load();
int loadmap();
int plotfruit();
int genrandom(int r);
int endgame();
int checkscore();
int gameoverclick(const Position &p);
int turn();
int gamewindowclick(const Position &p);
int move();
int check();
int plotbonusfruit();
int timerclick();
int handleBonusFruit();
int hsclick(const Position &p);
int highsclick(const Position &p);
int instrucclick(const Position &p);
int drawnumber();

// main program
int ApiMain()
{	
	HSload();
	menu.Open();
	loadmenu();
	mainmenu();
	return 0;
}

int HSload()
{
	ifstream in;
	in.open("scores.h");
	for(int i=0;i<3;i++)
		in>>HS[i];
	in.close();
	return 0;
}

int loadmenu()
{
	
	//load the images on the opening screen
	
	background.Load("backg.xpm");
	background.SetPosition(Position(0,0));
	
	return 0;
}

int mainmenu()
{
	
	background.Draw();
	menu.SetMouseClickCallback(mainmenuclick);
	return 0;
}

int mainmenuclick(const Position &p)
{
	if(((p.GetXDistance()>0.8)&&(p.GetXDistance()<7.2))&&((p.GetYDistance()>1.8)&&(p.GetYDistance()<2.9)))
	{
		menu.Close();
	    loadgame();
	}
	else if(((p.GetXDistance()>0.8)&&(p.GetXDistance()<7.2))&&((p.GetYDistance()>3.3)&&(p.GetYDistance()<4.4)))
	{
		HSdisplay();
	}
	else if(((p.GetXDistance()>0.7)&&(p.GetXDistance()<7.3))&&((p.GetYDistance()>4.8)&&(p.GetYDistance()<5.9)))
	{
		loadinstructions();
	}
	else if(((p.GetXDistance()>0.8)&&(p.GetXDistance()<7.2))&&((p.GetYDistance()>6.4)&&(p.GetYDistance()<7.5)))
	{
		menu.Close();
		exit(0);
	}
	
	return 0;
}

int HSdisplay()
{
	// code to display the highscores
	
	highs.Open();
	zero.Load("0.xpm");
	one.Load("1.xpm");
	two.Load("2.xpm");
	three.Load("3.xpm");
	four.Load("4.xpm");
	five.Load("5.xpm");
	six.Load("6.xpm");
	seven.Load("7.xpm");
	eight.Load("8.xpm");
	nine.Load("9.xpm");
	highback.Load("highback.xpm");
	highback.SetPosition(Position(0,0));
	highback.Draw();
	back.Load("back.xpm");
	back.SetPosition(Position(6.392,6.672));
	back.Draw();
	n=HS[0];
	r=n%10;
	n=n/10;
	c=1;
	drawnumber();
	r=n%10;
	n=n/10;
	c=2;
	drawnumber();
	r=n%10;
	n=n/10;
	c=3;
	drawnumber();
	r=n%10;
	n=n/10;
	c=4;
	drawnumber();
	n=HS[1];
	r=n%10;
	n=n/10;
	c=5;
	drawnumber();
	r=n%10;
	n=n/10;
	c=6;
	drawnumber();
	r=n%10;
	n=n/10;
	c=7;
	drawnumber();
	r=n%10;
	n=n/10;
	c=8;
	drawnumber();
	n=HS[2];
	r=n%10;
	n=n/10;
	c=9;
	drawnumber();
	r=n%10;
	n=n/10;
	c=10;
	drawnumber();
	r=n%10;
	n=n/10;
	c=11;
	drawnumber();
	r=n%10;
	n=n/10;
	c=12;
	drawnumber();
	highs.SetMouseClickCallback(highsclick);
	return 0;
}

int highsclick(const Position &p)
{
	if(highback.IsInside(p))
	{
		highs.Close();
	}
	return 0;
}
		

int loadinstructions()
{
	// havent set the orientation of the bitmap yet
	instruc.Open();
        instructions.Load("instructions.xpm");
	instructions.SetPosition(Position(0,0));
	instructions.Draw();
        b.Load("back.xpm");
        b.SetPosition(Position(6.392,6.672));
	b.Draw();
	instruc.SetMouseClickCallback(instrucclick);
	return 0;
}

int instrucclick(const Position &p)
{
	if(instructions.IsInside(p))
	{
		instruc.Close();
	}
	return 0;
}
		

int loadgame()
{
	game.Open();
	head.Load("headR.xpm");
	body.Load("snakebody.xpm");
	wall.Load("wall.xpm");
	bonusfruit.Load("bonusfruit.xpm");
	score=0;
	levelscore=0;
	length=4;
	level=1;
	lives=3;
	lengthinc=0;
		
	//starting the game
	playgame();
	return 0;
}

int playgame()
{
	blank.Load("blank.xpm");
	blank.SetPosition(Position(0,0));
    blank.Draw();
	load();
	game.StartTimer(300);
    game.SetMouseClickCallback(gamewindowclick);
	game.SetTimerCallback(timerclick);
	
}

int timerclick()
{
	//call the following functions repeatedly after a certain time interval
	if(bonusfruitpresence)
		handleBonusFruit();
	move();
	return 0;
}

int handleBonusFruit()
{
	
	//conditions for the presence of the bonus fruit
	if(countr<20)
	{
		if(countr%2==0)
			bonusfruit.Draw();
		else {
			bonusfruit.Erase();
		}
		countr++;
	}

	else
	{
		countr=0;
		map[xbonusfruit][ybonusfruit]=0;
		bonusfruitpresence=0;
	}
	return 0;
}


int gamewindowclick(const Position &p)
{
	//if the direction of the snake is up or down then to change it, following code works:
	if(direc=='U'|| direc=='D')
	{
		//if the mouse click is to the left of the snake, then turn left
		if(p.GetXDistance()*2.5<snake[0].x)
		{
			direc='L';
		}
		//if the mouse click is to the right of the snake, then turn right
		else if(p.GetXDistance()*2.5>snake[0].x)
		{
			direc='R';
		}
	}
	//if the direction of the snake is left or right then to change it, following code works:
	else
	{
		//if the mouse click is above the snake, then turn upwards
		if(p.GetYDistance()*2.5<snake[0].y)
		{
			direc='U';
		}
		//if the mouse click is below the snake, then turn downwards 
		else if(p.GetYDistance()*2.5>snake[0].y)
		{
			direc='D';
		}
	}
	//turn the snake in the new direction
	turn();
	//move the snake
	move();
	return 0;
}


int load()
{
	// loading the next level check if game is over
	if (level>5) {
		endgame();
		return 0;
	}
	loadmap();
	plotfruit();
	direc='R';
	turn();
	return 0;
	
}

int turn()
{
	//switches according to the newly assigned direction
	switch(direc)
	{
			//changes the image for head and tail as per the new direction
		case 'U' : head.Load("headU.xpm");
			break;
		case 'D' : head.Load("headD.xpm");
			break;
		case 'R' : head.Load("headR.xpm");
			break;
		case 'L' : head.Load("headL.xpm");
			break;
	}
	return 0;
}

int move()
{
	//Store the initial co-ordinates of head
	int tempX1,tempX2,tempY1,tempY2;	
	tempX1=snake[0].x; tempY1=snake[0].y;
	tempX2=snake[1].x; tempY2=snake[1].y;
	//"for" loop to transfer the co-ordinates of a body part to the next body part
	for(int i=1;(i<length-1);i++)
	{
		snake[i].x=tempX1; snake[i].y=tempY1;
		tempX1=tempX2; tempY1=tempY2;
		tempX2=snake[i+1].x; tempY2=snake[i+1].y;
	}
	
	if(lengthinc)
	{
		snake[length-1].x=snake[length-2].x;
		snake[length-1].y=snake[length-2].y;
		lengthinc=0;
	}
	else
	{
		snake[length-1].x=tempX1;snake[length-1].y=tempY1;
	}
	
	switch(direc)
	{
			//if snake goes upwards
		case 'U' : snake[0].y-=1;
			break;
			//if snake goes downwards
		case 'D' : snake[0].y+=1;
			break;
			//if snake goes left
		case 'L' : snake[0].x-=1;
			break;
			//if snake goes right
		case 'R' : snake[0].x+=1;
			break;
	}
	
	
	
	//generate new coordinates for the snake to come from left of screen to right of screen
	//generate new coordinates for the snake to come from top of screen to bottom of the screen
	
	if(snake[0].x==20)
		snake[0].x=0;
	else if(snake[0].x==-1)
		snake[0].x=19;
	if(snake[0].y==20)
		snake[0].y=0;	
	else if(snake[0].y==-1)
		snake[0].y=19;
	
	//cout<<snake[0][1]<<" "<<snake[1][1]<<" "<<snake[2][1] << endl; //used for debugging while checking the program
	//cout << subLevel;
	
	int chk=check();
	int bodylength=(chk==1)?length-2:length;
	//Setting new position for image of head
	//head.Erase();
	head.SetPosition(Position((float)(snake[0].x)*(.4),((float)snake[0].y)*(.4)));
	head.Draw();
	
	//Setting new position for image of body
	body.Erase();
	for(int i=1; i<bodylength; i++)
	{
		body.SetPosition(Position((float)(snake[i].x)/2.5,(float)(snake[i].y)/2.5));
		body.Draw();
	}
	return 0;
}

int check()
{
	/*
	 map[][]=1 means there is a wall on that position
	 map[][]=2 means there is a bonus fruit on that position
	 map[][]=3 means there is a fruit on that position
	 */
	
	
	//The snake collides with wall
	if(map[snake[0].x][snake[0].y]==1)
	{
		if(lives!=0)
		{
			lives--;
			length=4;
			levelscore=0;
			//scorePane('L');
			
			playgame();
		}
		else
		{
			//level=11;
			//restart the game
			game.StopTimer();
			endgame();
		}
		return 0;
	}
	
	//The snake eats the fruit	
	else if(map[snake[0].x][snake[0].y]==3)
	{
		map[snake[0].x][snake[0].y]=0;
		//if the number of fruits eaten is less than 10
		if(length<20)
		{
			//change the sublevel(that is the no. of fruits eaten)
			length+=2;
			lengthinc=1;
			
			//adding scores
			levelscore+=20;
			
			// needs update
			//plotting bonus fruit as per the case
			if(length==10 || length==18)
			{
				plotbonusfruit();
				bonusfruitpresence=1;
			}
			//plot the next fruit
			plotfruit();
			return 1;
		}
		
		//if number of the fruits eaten is 10 
		else
		{
			if(level==5)
				endgame();
			else
			{
				//go to the next level
				level++;
				//snake comes back to initial length
				length=4;
				levelscore+=20;
				score+=levelscore;
				levelscore=0;
				
				game.StopTimer();
				
				//start the next level
				playgame();
			}
			return 0;
		} 
	}
	else if(map[snake[0].x][snake[0].y]==2)
	{
		levelscore+=50;
		map[xbonusfruit][ybonusfruit]=0;
		return 0;
	}
	//The snake collides with the body
	else
	{
		for(int i=1; i<length; i++)
		{
			//Co-ordinates of head and a body part become same
			if(snake[0].x==snake[i].x && snake[0].y==snake[i].y)
			{
				//game over
				if(lives!=0)
				{
					lives--;
					//scorePane('L');
					length=4;
					levelscore=0;
					playgame();
				}
				else
				{
					//level=11;
					//w.StopTimer();
					game.StopTimer();
					endgame();
					//restart the game
					//playGame();
				}
				return 0;
			}
		}
	}
	
}



int loadmap()
{
	blank.Load("blank.xpm");
	blank.SetPosition(Position(0,0));
    blank.Draw();
	char a[10]="map1.h";
	FILE *fp;
	a[3]=(char)(48+level);
	fp=fopen(a,"r");
		
		
	//load the wall where map array contains '1'
	// need to update this
		
		for(int i=0; i<20; i++)
		{
			for(int j=0; j<20; j++)
			{
				fscanf(fp, "%d", &map[i][j]);
				if(map[i][j]==1)
				{
					wall.SetPosition(Position((float)i*.4, (float)j*.4));
					wall.Draw();
				}
			}
		}
		
		//initial position of the snake as per the level
		for(int i=0; i<4;i++)
		{
				
			fscanf(fp, "%d", &snake[i].x);
			fscanf(fp, "%d", &snake[i].y);
		}
		
		fclose(fp);
		
		//drawing the snake at the initial co-ordinates
	head.SetPosition(Position((float)snake[0].x*(.4),(float)snake[0].y*(.4)));
	head.Draw();
	body.SetPosition(Position((float)snake[1].x*(.4),(float)snake[1].y*(.4)));
	body.Draw();
	body.SetPosition(Position((float)snake[2].x*(.4),(float)snake[2].y*(.4)));
	body.Draw();
	body.SetPosition(Position((float)snake[3].x*(.4),(float)snake[3].y*(.4)));
	body.Draw();
	
	return 0;
}


int plotfruit()
{
	int flag=1;
	while(flag==1)	
	{
		flag=0;
		// needs update
		//generating random co-ordinates for the fruit
		xfruit=genrandom(20);
		yfruit=genrandom(20);
		//if the co-ordinates generated lie on wall or snake or bonus fruit
		//checking for wall and bonus fruit
		if(map[xfruit][yfruit]==1 || map[xfruit][yfruit]==2)
		{
			flag=1;
		}
		//checking for snake
		else
		{
			for(int i=0; i<length; i++)
			{
				if(snake[i].x==xfruit && snake[i].y==yfruit)
					flag=1;
			}
		}
	}	//if flag=1, generate another pair of co-ordinates
	
	//setting new fruit co-ordinate to 3
	map[xfruit][yfruit]=3;
	
	//random fruit type
	int fruitRand=genrandom(3);
	string a="fruit";
	string c=".xpm";
	string imageF =a+(char)(49+fruitRand)+c;
	//loading new fruit
	fruit.Load(imageF);
	fruit.SetPosition(Position((float)xfruit/2.5,(float)yfruit/2.5));
	fruit.Draw();
		
	return 0;
}  

int plotbonusfruit()
{
	int flag=1;
	while(flag==1)
	{	
		flag=0;
		
		//generating random co-ordinates for the fruit
		xbonusfruit=genrandom(20);
		ybonusfruit=genrandom(20);
		
		//if the co-ordinates generated lie on wall or snake
		//checking for wall
		if(map[xbonusfruit][ybonusfruit]==1 || map[xbonusfruit][ybonusfruit]==3)
		{
			flag=1;
		}
		//checking for snake
		else
		{
			for(int i=0; i<length; i++)
			{
				if(snake[i].x==xbonusfruit && snake[i].y==ybonusfruit)
					flag=1;
			}
		}
	}
	
	map[xbonusfruit][ybonusfruit]=2;
	
	bonusfruit.SetPosition(Position((float)xbonusfruit/2.5,(float)ybonusfruit/2.5));
	bonusfruit.Draw();
	
	return 0;
}


int genrandom(int r)
{
	srand(GetMilliseconds());
	
  	return rand()%r;
}

int endgame()
{	
  	gameover.Open();	
	
	// needs update
	int rank=checkscore();
	
	//w.Close();
	if(rank<0)
	{       
		gameover.Open();
		go.Load("gameover.xpm");
		go.SetPosition(Position(0,0));
		go.Draw();
		gameover.SetMouseClickCallback(gameoverclick);
		return 0;
	}
	else
	{
		hs.Open();
		if(rank==1)
			highscore.Load("congrats1.xpm");
		else if(rank==2)
			highscore.Load("congrats2.xpm");
		else if(rank==3)
			highscore.Load("congrats3.xpm");
		highscore.SetPosition(Position(0,0));
		highscore.Draw();
		hs.SetMouseClickCallback(hsclick);
		return 0;
	}
	game.Close();
}

int checkscore()
{
	int i=0, flag=0;
	for(i=0;i<3;i++)
	{
		if(score>HS[i])
		{
			for(int j=2;j>i;j--)
			{
				HS[j]=HS[j-1];
			}
			HS[i]=score;
			flag=1;
			ofstream write;
			write.open("scores.h",ios::out | ios::trunc);
			for(int k=0;k<3;k++)
				write<<HS[k]<<"\n";
			write.close();
		}
		if(flag==1) break;
	}
	if(flag==1)
		return i+1;
	else 
		return -1;
}

int gameoverclick(const Position &p)
{
	
	if(p.GetXDistance()>4.0)
	{
		gameover.Close();
		menu.Open();
		loadmenu();
		mainmenu();
	}
	else if(p.GetXDistance()<4.0)
	{
		gameover.Close();
		exit(0);
	}
	return 0;
} 

int hsclick(const Position &p)
{
	if(highscore.IsInside(p))
	{
		hs.Close();
		menu.Open();
		loadmenu();
		mainmenu();
	}
	return 0;
}
	
int drawnumber()
{
	switch(r){
		case 0:
			
		switch(c)
		{
			case 1: zero.SetPosition(Position(4.904,1.992));
				zero.Draw();
				break;
			case 2: zero.SetPosition(Position(4.136,1.992));
				zero.Draw();
				break;
			case 3: zero.SetPosition(Position(3.368,1.992));
				zero.Draw();
				break;
			case 4: zero.SetPosition(Position(2.6,1.992));
				zero.Draw();
				break;
			case 5: zero.SetPosition(Position(4.904,3.472));
				zero.Draw();
				break;
			case 6: zero.SetPosition(Position(4.136,3.472));
				zero.Draw();
				break;
			case 7: zero.SetPosition(Position(3.368,3.472));
				zero.Draw();
				break;
			case 8: zero.SetPosition(Position(2.6,3.472));
				zero.Draw();
				break;
			case 9: zero.SetPosition(Position(4.904,4.952));
				zero.Draw();
				break;
			case 10: zero.SetPosition(Position(4.136,4.952));
				zero.Draw();
				break;
			case 11: zero.SetPosition(Position(3.368,4.952));
				zero.Draw();
				break;
			case 12: zero.SetPosition(Position(2.6,4.952));
				zero.Draw();
				break;
		}
			break;
			
		case 1:
			
			switch(c)
		{
			case 1: one.SetPosition(Position(4.904,1.992));
				one.Draw();
				break;
			case 2: one.SetPosition(Position(4.136,1.992));
				one.Draw();
				break;
			case 3: one.SetPosition(Position(3.368,1.992));
				one.Draw();
				break;
			case 4: one.SetPosition(Position(2.6,1.992));
				one.Draw();
				break;
			case 5: one.SetPosition(Position(4.904,3.472));
				one.Draw();
				break;
			case 6: one.SetPosition(Position(4.136,3.472));
				one.Draw();
				break;
			case 7: one.SetPosition(Position(3.368,3.472));
				one.Draw();
				break;
			case 8: one.SetPosition(Position(2.6,3.472));
				one.Draw();
				break;
			case 9: one.SetPosition(Position(4.904,4.952));
				one.Draw();
				break;
			case 10: one.SetPosition(Position(4.136,4.952));
				one.Draw();
				break;
			case 11: one.SetPosition(Position(3.368,4.952));
				one.Draw();
				break;
			case 12: one.SetPosition(Position(2.6,4.952));
				one.Draw();
				break;
		}
			break;
			
		case 2:
			
			switch(c)
		{
			case 1: two.SetPosition(Position(4.904,1.992));
				two.Draw();
				break;
			case 2: two.SetPosition(Position(4.136,1.992));
				two.Draw();
				break;
			case 3: two.SetPosition(Position(3.368,1.992));
				two.Draw();
				break;
			case 4: two.SetPosition(Position(2.6,1.992));
				two.Draw();
				break;
			case 5: two.SetPosition(Position(4.904,3.472));
				two.Draw();
				break;
			case 6: two.SetPosition(Position(4.136,3.472));
				two.Draw();
				break;
			case 7: two.SetPosition(Position(3.368,3.472));
				two.Draw();
				break;
			case 8: two.SetPosition(Position(2.6,3.472));
				two.Draw();
				break;
			case 9: two.SetPosition(Position(4.904,4.952));
				two.Draw();
				break;
			case 10: two.SetPosition(Position(4.136,4.952));
				two.Draw();
				break;
			case 12: two.SetPosition(Position(2.6,4.952));
				two.Draw();
				break;
		}
			break;
			
		case 3:
			
			switch(c)
		{
			case 1: three.SetPosition(Position(4.904,1.992));
				three.Draw();
				break;
			case 2: three.SetPosition(Position(4.136,1.992));
				three.Draw();
				break;
			case 3: three.SetPosition(Position(3.368,1.992));
				three.Draw();
				break;
			case 4: three.SetPosition(Position(2.6,1.992));
				three.Draw();
				break;
			case 5: three.SetPosition(Position(4.904,3.472));
				three.Draw();
				break;
			case 6: three.SetPosition(Position(4.136,3.472));
				three.Draw();
				break;
			case 7: three.SetPosition(Position(3.368,3.472));
				three.Draw();
				break;
			case 8: three.SetPosition(Position(2.6,3.472));
				three.Draw();
				break;
			case 9: three.SetPosition(Position(4.904,4.952));
				three.Draw();
				break;
			case 10: three.SetPosition(Position(4.136,4.952));
				three.Draw();
				break;
			case 11: three.SetPosition(Position(3.368,4.952));
				three.Draw();
				break;
			case 12: three.SetPosition(Position(2.6,4.952));
				three.Draw();
				break;
		}
			break;
			
		case 4:
			
			switch(c)
		{
			case 1: four.SetPosition(Position(4.904,1.992));
				four.Draw();
				break;
			case 2: four.SetPosition(Position(4.136,1.992));
				four.Draw();
				break;
			case 3: four.SetPosition(Position(3.368,1.992));
				four.Draw();
				break;
			case 4: four.SetPosition(Position(2.6,1.992));
				four.Draw();
				break;
			case 5: four.SetPosition(Position(4.904,3.472));
				four.Draw();
				break;
			case 6: four.SetPosition(Position(4.136,3.472));
				four.Draw();
				break;
			case 7: four.SetPosition(Position(3.368,3.472));
				four.Draw();
				break;
			case 8: four.SetPosition(Position(2.6,3.472));
				four.Draw();
				break;
			case 9: four.SetPosition(Position(4.904,4.952));
				four.Draw();
				break;
			case 10: four.SetPosition(Position(4.136,4.952));
				four.Draw();
				break;
			case 11: four.SetPosition(Position(3.368,4.952));
				four.Draw();
				break;
			case 12: four.SetPosition(Position(2.6,4.952));
				four.Draw();
				break;
		}
			break;
			
		case 5:
			
			switch(c)
		{
			case 1: five.SetPosition(Position(4.904,1.992));
				five.Draw();
				break;
			case 2: five.SetPosition(Position(4.136,1.992));
				five.Draw();
				break;
			case 3: five.SetPosition(Position(3.368,1.992));
				five.Draw();
				break;
			case 4: five.SetPosition(Position(2.6,1.992));
				five.Draw();
				break;
			case 5: five.SetPosition(Position(4.904,3.472));
				five.Draw();
				break;
			case 6: five.SetPosition(Position(4.136,3.472));
				five.Draw();
				break;
			case 7: five.SetPosition(Position(3.368,3.472));
				five.Draw();
				break;
			case 8: five.SetPosition(Position(2.6,3.472));
				five.Draw();
				break;
			case 9: five.SetPosition(Position(4.904,4.952));
				five.Draw();
				break;
			case 10: five.SetPosition(Position(4.136,4.952));
				five.Draw();
				break;
			case 11: five.SetPosition(Position(3.368,4.952));
				five.Draw();
				break;
			case 12: five.SetPosition(Position(2.6,4.952));
				five.Draw();
				break;
		}
			break;
			
		case 6:
			
			switch(c)
		{
			case 1: six.SetPosition(Position(4.904,1.992));
				six.Draw();
				break;
			case 2: six.SetPosition(Position(4.136,1.992));
				six.Draw();
				break;
			case 3: six.SetPosition(Position(3.368,1.992));
				six.Draw();
				break;
			case 4: six.SetPosition(Position(2.6,1.992));
				six.Draw();
				break;
			case 5: six.SetPosition(Position(4.904,3.472));
				six.Draw();
				break;
			case 6: six.SetPosition(Position(4.136,3.472));
				six.Draw();
				break;
			case 7: six.SetPosition(Position(3.368,3.472));
				six.Draw();
				break;
			case 8: six.SetPosition(Position(2.6,3.472));
				six.Draw();
				break;
			case 9: six.SetPosition(Position(4.904,4.952));
				six.Draw();
				break;
			case 10: six.SetPosition(Position(4.136,4.952));
				six.Draw();
				break;
			case 11: six.SetPosition(Position(3.368,4.952));
				six.Draw();
				break;
			case 12: six.SetPosition(Position(2.6,4.952));
				six.Draw();
				break;
		}
			break;
			
		case 7:
			
			switch(c)
		{
			case 1: seven.SetPosition(Position(4.904,1.992));
				seven.Draw();
				break;
			case 2: seven.SetPosition(Position(4.136,1.992));
				seven.Draw();
				break;
			case 3: seven.SetPosition(Position(3.368,1.992));
				seven.Draw();
				break;
			case 4: seven.SetPosition(Position(2.6,1.992));
				seven.Draw();
				break;
			case 5: seven.SetPosition(Position(4.904,3.472));
				seven.Draw();
				break;
			case 6: seven.SetPosition(Position(4.136,3.472));
				seven.Draw();
				break;
			case 7: seven.SetPosition(Position(3.368,3.472));
				seven.Draw();
				break;
			case 8: seven.SetPosition(Position(2.6,3.472));
				seven.Draw();
				break;
			case 9: seven.SetPosition(Position(4.904,4.952));
				seven.Draw();
				break;
			case 10: seven.SetPosition(Position(4.136,4.952));
				seven.Draw();
				break;
			case 11: seven.SetPosition(Position(3.368,4.952));
				seven.Draw();
				break;
			case 12: seven.SetPosition(Position(2.6,4.952));
				seven.Draw();
				break;
		}
			break;
			
		case 8:
			
			switch(c)
		{
			case 1: eight.SetPosition(Position(4.904,1.992));
				eight.Draw();
				break;
			case 2: eight.SetPosition(Position(4.136,1.992));
				eight.Draw();
				break;
			case 3: eight.SetPosition(Position(3.368,1.992));
				eight.Draw();
				break;
			case 4: eight.SetPosition(Position(2.6,1.992));
				eight.Draw();
				break;
			case 5: eight.SetPosition(Position(4.904,3.472));
				eight.Draw();
				break;
			case 6: eight.SetPosition(Position(4.136,3.472));
				eight.Draw();
				break;
			case 7: eight.SetPosition(Position(3.368,3.472));
				eight.Draw();
				break;
			case 8: eight.SetPosition(Position(2.6,3.472));
				eight.Draw();
				break;
			case 9: eight.SetPosition(Position(4.904,4.952));
				eight.Draw();
				break;
			case 10: eight.SetPosition(Position(4.136,4.952));
				eight.Draw();
				break;
			case 11: eight.SetPosition(Position(3.368,4.952));
				eight.Draw();
				break;
			case 12: eight.SetPosition(Position(2.6,4.952));
				eight.Draw();
				break;
		}
			break;
			
		case 9:
			
			switch(c)
		{
			case 1: nine.SetPosition(Position(4.904,1.992));
				nine.Draw();
				break;
			case 2: nine.SetPosition(Position(4.136,1.992));
				nine.Draw();
				break;
			case 3: nine.SetPosition(Position(3.368,1.992));
				nine.Draw();
				break;
			case 4: nine.SetPosition(Position(2.6,1.992));
				nine.Draw();
				break;
			case 5: nine.SetPosition(Position(4.904,3.472));
				nine.Draw();
				break;
			case 6: nine.SetPosition(Position(4.136,3.472));
				nine.Draw();
				break;
			case 7: nine.SetPosition(Position(3.368,3.472));
				nine.Draw();
				break;
			case 8: nine.SetPosition(Position(2.6,3.472));
				nine.Draw();
				break;
			case 9: nine.SetPosition(Position(4.904,4.952));
				nine.Draw();
				break;
			case 10: nine.SetPosition(Position(4.136,4.952));
				nine.Draw();
				break;
			case 11: nine.SetPosition(Position(3.368,4.952));
				nine.Draw();
				break;
			case 12: nine.SetPosition(Position(2.6,4.952));
				nine.Draw();
				break;
		}
			break;
			
	}
	return 0;
}
		













